#include "Interface.h"
#include "Blacklist.h"
#include "BlacklistInterface.h"

static Blacklist *blacklist;
static Lock loadLock;

int blacklist_load()
{
	LockUnique l(&loadLock.l); if (!l.ok) return 0;

	blacklist = new Blacklist();
	return 0;
}

void blacklist_unload()
{
	LockUnique l(&loadLock.l); if (!l.ok) return;

	if (blacklist) {
		delete blacklist;
		blacklist = NULL;
	}
}

void blacklist_print(const int fd)
{
	LockShared l(&loadLock.l);
	if (!blacklist) {
		return;
	}
	blacklist->print(fd);
}

int blacklist_match(const char *number)
{
	LockShared l(&loadLock.l);
	if (!blacklist) {
		return 0;
	}
	return blacklist->match(number);
}
