#include "Interface.h"
#include "CallConstraints.h"
#include "CallConstraintsInterface.h"

static CallConstraints *callConstraints;
static Lock loadLock;

int callconstraints_load()
{
	LockUnique l(&loadLock.l);
	if (!l.ok) return 0;

	callConstraints = new CallConstraints();
	return 0;
}

void callconstraints_unload()
{
	LockUnique l(&loadLock.l);
	if (!l.ok) return;

	if (callConstraints) {
		delete callConstraints;
		callConstraints = NULL;
	}
}

int callconstraints_test(const char *dialedNumber)
{
	LockShared l(&loadLock.l);
	if (!callConstraints) {
		return 0;
	}
	return callConstraints->test(dialedNumber);
}

void callconstraints_print(const int fd, const int concise)
{
	LockShared l(&loadLock.l);
	if (!callConstraints) {
		return;
	}

	if (0 == concise) {
		return callConstraints->print(fd);
	}
	else {
		return callConstraints->printConcise(fd);
	}
}

int callconstraints_sched_exec(const void *data)
{
	LockShared l(&loadLock.l);
	if (!callConstraints) {
		return 1; /* reschedule */
	}

	callConstraints->schedCheck();
	
	return 1; /* reschedule */
}
