#ifndef CALL_HISTORY_H
#define	CALL_HISTORY_H
#include "Common.h"

class CallHistory {
private:
	SqliteWrapper sqlite;

	bool openDatabase(bool check = false);
	void closeDatabase();
	bool createDatabase();
	bool checkDatabase();
	void updateCallHistoryStatus(KTS_CallHistoryStatus &status, const std::string value);
	std::string readCdrVariable(struct ast_cdr *p_cdr, const std::string &name, const std::string defaultValue = "");
	void asteriskUpdateParam(struct ast_channel *chan, const std::string paramName, const std::string paramValue, bool rewriteInit);
	void amiSendMessage(const std::string &fromNum, const std::string &toNum);
	void updateExtensionTypes(const std::string fromNum, const std::string toNum, KTS_ExtensionType &fromType, KTS_ExtensionType & toType);
	std::string getCodecName(const std::string &codecName);
public:
	CallHistory();
	~CallHistory();
	int cdrLog(struct ast_cdr * p_cdr);
	void asteriskUpdateParams(struct ast_channel *chan, const std::string argStr);
	int getCallsCountPrefix(int scope, std::vector<std::string> prefixes, int timeframe);
	int getCallsDurationPrefix(int scope, std::vector<std::string> prefixes, int timeframe);
};

#endif	/* CALL_HISTORY_H */

