#ifndef CALL_PERMISSIONS_H
#define	CALL_PERMISSIONS_H

#include "Common.h"

class CallPermissions {
private:
	int testPermissionsExtension(std::string &groupName, const std::string extensionNumber, const std::string dialedNumber);
	int testPermissionsInterface(std::string &groupName, const std::string interfaceName, const std::string dialedNumber);
public:

	typedef std::multimap<int, CallPermissionsEntry> CallPermissionList; /* key is groupId */
	typedef std::map<std::string, CallPermissionsExtension> ExtensionList; /* key is telNum */
	typedef std::map<std::string, CallPermissionsInterface> InterfaceList; /* key is name */
	typedef std::set<std::string> EmergencyList;
	typedef std::set<std::string> RouteList;
	typedef std::map<std::string, CallPermissionsDisabledExtension> DisabledExtensionList; /* key is telNum */

	CallPermissionList callPermissionList;
	ExtensionList extensionList;
	InterfaceList interfaceList;
	EmergencyList emergencyList;
	RouteList routeList;
	DisabledExtensionList disabledExtensionList;

	CallPermissions();
	~CallPermissions();
	int testPermissions(const std::string source, const std::string dialedNumber);
};

#endif	/* CALL_PERMISSIONS_H */

