#include "Interface.h"
#include "Dialplan.h"
#include "DialplanInterface.h"

static DialPlan *dialPlan;
static Lock loadLock;

int dialplan_load()
{
	LockUnique l(&loadLock.l); if (!l.ok) return 0;

	dialPlan = new DialPlan();
	return 0;
}

void dialplan_unload()
{
	LockUnique l(&loadLock.l); if (!l.ok) return;

	if (dialPlan) {
		delete dialPlan;
		dialPlan = NULL;
	}
}

void dialplan_printExtensions(const int fd)
{
	LockShared l(&loadLock.l);
	if (!dialPlan) {
		return;
	}
	dialPlan->printExtensions(fd);
}

int dialplan_findExt(const char *number)
{
	LockShared l(&loadLock.l);
	if (!dialPlan) {
		return 0;
	}
	return dialPlan->findDialByExt(number);
}
